if (${CMAKE_VERSION} VERSION_GREATER 2.8.4)
  # This is necessary as of CMake version 2.8.8
  cmake_policy(SET CMP0017 NEW)
  # set(CMAKE_ECLIPSE_MAKE_ARGUMENTS "-j8")
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)

set(Boost_ADDITIONAL_VERSIONS "1.46" "1.46.1" "1.47" "1.47.1")
#set(Boost_DEBUG TRUE) # Activate me to debug problems finding Boost
set(Boost_DETAILED_FAILURE_MESSAGE TRUE)
find_package(Boost 1.46 COMPONENTS serialization REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})


# uninstall target
# adapted from
# http://www.cmake.org/Wiki/CMake_FAQ#Can_I_do_.22make_uninstall.22_with_CMake.3F
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
