#include <iostream>

#include <boost/foreach.hpp>

#include "schema.hh"

using namespace std;

namespace jazzy_world
{

static Artist::pointer      p_davis(new Artist("Miles Davis"));
static Album::pointer       p_kind_of_blue(new Album("Kind of blue"));
static Artist::pointer      p_chambers(new Artist("Paul Chambers"));
static Album::pointer       p_blue_moods(new Album("Blue Moods"));

void initialize()
{
    // plays_in::add(p_davis, p_kind_of_blue);
    p_davis->add<plays_in>(p_kind_of_blue);
    plays_in::add(p_chambers, p_kind_of_blue);
}

} // namespace jazzy_world



int
main(int argc, const char* argv[])
{
    using namespace jazzy_world;
    initialize();

    cout << "Showing some Yams++ features..." << endl;

    BOOST_FOREACH(Artist::pointer artist,
                  p_kind_of_blue->rev_iter<plays_in>())
    {
        cout << artist->name << " plays in album " << p_kind_of_blue->title << endl;
    }
    return 0;
}
