#ifndef YAMS_EXAMPLE__SCHEMA__INCLUDED
#define YAMS_EXAMPLE__SCHEMA__INCLUDED

#include <string>

#include <yams/yams.hh>

struct Album;
struct Artist;

struct plays_in_rtype {};

// The extern keyword is C++'11 : it means NOT to instanciate the template
// HERE as we instanciate it explicitely ONCE in schema.cc.
// This is a significative optimization regarding compile time but omiting
// on compiler supporting only C++'03 should have no semantic consequences.
extern template class RelationDefinition<plays_in_rtype, Artist, Album>;
typedef RelationDefinition<plays_in_rtype, Artist, Album> plays_in;

struct Album : public Entity<Album>
{
    Album(const std::string& title_) : title(title_) {};
    std::string title;
};

struct Artist : public Entity<Artist>
{
    Artist(const std::string& name_) : name(name_) {};
    std::string name;
};


#endif // YAMS_EXAMPLE__SCHEMA__INCLUDED
